=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2008-12-11 19:37:06 +0000
+++ bzrlib/osutils.py	2009-01-07 00:58:30 +0000
@@ -1549,7 +1549,7 @@
     """
     b = ''
     while len(b) < bytes:
-        new = socket.recv(bytes - len(b))
+        new = until_no_eintr(socket.recv, bytes - len(b))
         if new == '':
             break # eof
         b += new
@@ -1564,7 +1564,7 @@
     """
     chunk_size = 2**16
     for pos in xrange(0, len(bytes), chunk_size):
-        socket.sendall(bytes[pos:pos+chunk_size])
+        until_no_eintr(socket.sendall, bytes[pos:pos+chunk_size])
 
 
 def dereference_path(path):
@@ -1637,6 +1637,18 @@
             raise errors.NoSuchFile(f)
         raise
 
+
+def until_no_eintr(f, *a, **kw):
+    # Borrowed from Twisted's twisted.python.util.untilConcludes function.
+    while True:
+        try:
+            return f(*a, **kw)
+        except (IOError, OSError), e:
+            if e.args[0] == errno.EINTR:
+                continue
+            raise
+
+
 if sys.platform == "win32":
     import msvcrt
     def getchar():

=== modified file 'bzrlib/smart/medium.py'
--- bzrlib/smart/medium.py	2008-10-02 13:25:47 +0000
+++ bzrlib/smart/medium.py	2009-01-07 00:58:30 +0000
@@ -274,7 +274,7 @@
     def _read_bytes(self, desired_count):
         # We ignore the desired_count because on sockets it's more efficient to
         # read large chunks (of _MAX_READ_SIZE bytes) at a time.
-        return self.socket.recv(_MAX_READ_SIZE)
+        return osutils.until_no_eintr(self.socket.recv, _MAX_READ_SIZE)
 
     def terminate_due_to_error(self):
         # TODO: This should log to a server log file, but no such thing

